import { IClassDecorator, Registration } from 'tsioc';
import { ControllerMetadata } from '../metadata';
/**
 * Controller decorator define.
 *
 * @export
 * @interface IControllerDecorator
 * @template T
 */
export interface IControllerDecorator<T extends ControllerMetadata> extends IClassDecorator<T> {
    (routePrefix: string, provide?: Registration<any> | string, alias?: string): ClassDecorator;
    (target: Function): void;
}
/**
 * Controller decorator and metadata.
 *
 * @Controller
 */
export declare const Controller: IControllerDecorator<ControllerMetadata>;
