"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tsioc_1 = require("tsioc");
var util_1 = require("util");
function createCorsDecorator(name, adapter, metadataExtends) {
    return tsioc_1.createClassMethodDecorator(name, function (args) {
        if (adapter) {
            adapter(args);
        }
        args.next({
            match: function (arg) { return util_1.isArray(arg) || util_1.isString(arg); },
            setMetadata: function (metatdata, arg) {
                if (util_1.isString(arg)) {
                    metatdata.allowMethods = arg;
                }
                else {
                    var allowMethods = arg;
                    metatdata.allowMethods = allowMethods.filter(function (m) { return !util_1.isUndefined(m) && m !== null; });
                }
            }
        });
        args.next({
            match: function (arg) { return util_1.isNumber(arg); },
            setMetadata: function (metatdata, arg) {
                metatdata.maxAge = arg;
            }
        });
        args.next({
            match: function (arg) { return util_1.isArray(arg); },
            setMetadata: function (metatdata, arg) {
                var allowHeaders = arg;
                metatdata.allowHeaders = allowHeaders.filter(function (h) { return !!h; });
            }
        });
    }, metadataExtends);
}
exports.createCorsDecorator = createCorsDecorator;
exports.Cors = createCorsDecorator('Cors');

//# sourceMappingURL=../../sourcemaps/core/decorators/Cors.js.map
