"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var ResultValue_1 = require("./ResultValue");
var stream_1 = require("stream");
var util_1 = require("../../util");
var Configuration_1 = require("../../Configuration");
var fs_1 = require("fs");
var path_1 = require("path");
var errors_1 = require("../../errors");
/**
 * controller method return result type of file.
 *
 * @export
 * @class FileResult
 */
var FileResult = /** @class */ (function (_super) {
    __extends(FileResult, _super);
    function FileResult(file, contentType, fileDownloadName) {
        var _this = _super.call(this, contentType) || this;
        _this.file = file;
        _this.fileDownloadName = fileDownloadName;
        return _this;
    }
    FileResult.prototype.sendValue = function (ctx, container) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            var defer, file, contentType, confige, filepath;
            return __generator(this, function (_a) {
                defer = util_1.Defer.create();
                file = this.file;
                contentType = this.contentType;
                confige = container.get(Configuration_1.Configuration);
                if (file instanceof String) {
                    filepath = path_1.join(confige.rootdir, file);
                    if (fs_1.existsSync(filepath)) {
                        fs_1.readFile(filepath, contentType || 'utf8', function (err, data) {
                            if (err) {
                                defer.reject(err);
                            }
                            else {
                                defer.resolve(new Buffer(data));
                            }
                        });
                    }
                }
                else if (file instanceof Buffer) {
                    defer.resolve(file);
                }
                else if (file instanceof stream_1.Stream) {
                    file.once('end', function (data) {
                        defer.resolve(new Buffer(data));
                    })
                        .once('error', defer.reject);
                }
                return [2 /*return*/, defer.promise
                        .then(function (buffer) {
                        if (_this.fileDownloadName) {
                            ctx.attachment(_this.fileDownloadName);
                        }
                        ctx.body = buffer;
                    }, function (err) {
                        throw new errors_1.BadRequestError(err.toString());
                    })];
            });
        });
    };
    return FileResult;
}(ResultValue_1.ResultValue));
exports.FileResult = FileResult;

//# sourceMappingURL=../../sourcemaps/core/results/FileResult.js.map
